"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _Context = require("./Context");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Socket provider for app
 */
var SocketProvider = function (_React$Component) {
  _inherits(SocketProvider, _React$Component);

  function SocketProvider(props) {
    _classCallCheck(this, SocketProvider);

    var _this = _possibleConstructorReturn(this, (SocketProvider.__proto__ || Object.getPrototypeOf(SocketProvider)).call(this, props));

    _this.state = {
      payload: null
    };
    return _this;
  }

  _createClass(SocketProvider, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _props = this.props,
          socket = _props.socket,
          shouldReconnect = _props.shouldReconnect;

      if (shouldReconnect) {
        socket.open();
      }
      socket.onevent = function (msg) {
        var _msg$data = _toArray(msg.data),
            type = _msg$data[0],
            data = _msg$data.slice(1);

        var payload = {
          type: type,
          data: data
        };
        _this2.setState({ payload: payload });
      };
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _props2 = this.props,
          socket = _props2.socket,
          shouldDisconnect = _props2.shouldDisconnect;

      if (shouldDisconnect) {
        socket.close();
      }
      socket.close();
    }
  }, {
    key: "render",
    value: function render() {
      var _props3 = this.props,
          children = _props3.children,
          socket = _props3.socket;
      var payload = this.state.payload;

      return _react2.default.createElement(
        _Context.MessageContext.Provider,
        {
          value: { payload: payload, emit: function emit(type) {
              for (var _len = arguments.length, rest = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                rest[_key - 1] = arguments[_key];
              }

              return socket.emit.apply(socket, [type].concat(rest));
            } }
        },
        _react2.default.createElement(
          _Context.SocketContext.Provider,
          { value: socket },
          children
        )
      );
    }
  }]);

  return SocketProvider;
}(_react2.default.Component);

SocketProvider.propTypes = {
  children: _propTypes2.default.node.isRequired,
  socket: _propTypes2.default.object.isRequired,
  shouldReconnect: _propTypes2.default.bool,
  shouldDisconnect: _propTypes2.default.bool
};

SocketProvider.defaultProps = {
  shouldReconnect: false,
  shouldDisconnect: false
};

exports.default = SocketProvider;