"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var SOCKET_ACTION = exports.SOCKET_ACTION = "@@socket/SOCKET_ACTION";
var EMIT_MESSAGE = exports.EMIT_MESSAGE = "@@socket/EMIT_MESSAGE";

/**
 * Action creator for saving socket data in store
 * @param {Object} payload object with data from socket
 * @returns {Object} created action
 */
var handleSocketAction = exports.handleSocketAction = function handleSocketAction(payload) {
  return {
    type: SOCKET_ACTION,
    payload: payload
  };
};

/**
 * Action creator for sending to store message to emit
 * @param {String} eventType type of event message
 * @param {Array} message rest params that will be send as body
 * @returns {Object} created action
 */
var emitMessage = exports.emitMessage = function emitMessage(eventType) {
  for (var _len = arguments.length, message = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    message[_key - 1] = arguments[_key];
  }

  return {
    type: EMIT_MESSAGE,
    payload: {
      eventType: eventType,
      message: message
    }
  };
};