"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _actions = require("./actions");

/**
 * Socket reducer which keeps data from socket
 * @param {Object} state previous state
 * @param {Object} action which need to make with state
 * @returns {Object} new state
 */
var socketReducer = function socketReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _ref = arguments[1];
  var type = _ref.type,
      payload = _ref.payload;

  if (type === _actions.SOCKET_ACTION) {
    return Object.assign({}, state, payload);
  }
  return state;
};

exports.default = socketReducer;